:li

interface Section
    {
    type properties:
        supertype: Atomic_Object;
        extent: sections;
        key: (course, section_number);

    instance properties:
        section_number: String; // unique within course
        days_offered: Set<Weekdays>;
        time_offered: Struct<from: Time, to: Time>;
        grade_curve: Set<Struct<no_of_students: Integer, grade: Integer>>;

        course: Course inverse Course::sections;
        students: Set<Student> inverse Student::take;
        taught_by: Professor inverse Professor::teaches;
        teaching_assistants: Set<TA> inverse TA::responsible_for;

    instance operations:
        cancel();
        reschedule(from: Struct<date: Date, time: Time>,
           to: Struct<date: Date, time: Time>) raises (unavailable);
};
